unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, OpenGLContext, Forms, Controls, Graphics,
  Dialogs, StdCtrls,dglOpenGL, Types, lclintf, Menus;

type

 frfloat=double;

 punkt3d=record
  x,y,z:frfloat;
 end;


  { TForm1 }

  TForm1 = class(TForm)
    Label1: TLabel;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    OpenGLControl1: TOpenGLControl;
    procedure FormCreate(Sender: TObject);
    procedure MenuItem4Click(Sender: TObject);
    procedure OpenGLControl1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure OpenGLControl1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure OpenGLControl1MouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure OpenGLControl1MouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure OpenGLControl1Paint(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

  position3d:punkt3d;
  Mausstart_3Dx:Integer;
  Mausstart_3Dy:Integer;

  winkel_um:punkt3d;
  picking:boolean=false;


implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin

 // Default Darstellungs-Winkel und Position des Körpers beim Start
 winkel_um.x:=10;
 winkel_um.y:=20;
 winkel_um.z:=0;
 position3d.x:=0;
 position3d.y:=0;
 position3d.z:=-0.35;

 { Beginn: Initialisierung von OpenGL bei Verwendung der dglOpenGL}
 InitOpenGL;
 OpenGLControl1.MakeCurrent;
 ReadExtensions;
 ReadImplementationProperties;

// OpenGLControl1.DoubleBuffered:=true;
 { End: Initialisierung von OpenGL bei Verwendung der dglOpenGL}

end;

procedure TForm1.MenuItem4Click(Sender: TObject);
begin
 close;
end;

procedure TForm1.OpenGLControl1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 // Mauspunkte merken
 Mausstart_3Dx:=x;
 Mausstart_3Dy:=y;

 picking:=true;
 // neu zeichnen
 self.OpenGLControl1.Invalidate;

end;

procedure TForm1.OpenGLControl1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var diff_x,diff_y,diff_z:extended;
begin
  // rotieren , schieben , zoomen

    // Flugzeug rotieren um die X- und Y-Achse
    // ssleft=linke Maustaste gedrückt
    if (ssleft in shift)
     then
      begin
       // Rotation um die X-Achse
       diff_y:=(y-Mausstart_3Dy);
       winkel_um.x:=
        winkel_um.x+diff_y;
       if winkel_um.x > 359 then
          winkel_um.x:=0;
       if winkel_um.x < 0 then
          winkel_um.x:=359;
       mausstart_3Dy:=y;
       // Rotation um die Y-Achse
       diff_x:=(x-Mausstart_3Dx);
       winkel_um.y:=
        winkel_um.y+diff_x;
       if winkel_um.y > 359 then
          winkel_um.y:=0;
       if winkel_um.y < 0 then
          winkel_um.y:=359;
       mausstart_3Dx:=x;

       // neu zeichnen
       self.OpenGLControl1.Invalidate;
      end;

    // Flugzeug verschieben in X- und Y-Achse
    // ssRight=rechte Maustaste gedrückt
    if (ssRight in shift)
     then
       begin
        // Verschieben in der X-Achse
        diff_x:=(x-Mausstart_3Dx)/1000;
        Position3d.x:=Position3d.x+diff_x;

        mausstart_3Dx:=x;

        // Verschieben in der Y-Achse
        diff_y:=(y-Mausstart_3Dy)/1000;
        Position3d.y:=Position3d.y-diff_y;

        mausstart_3Dy:=y;

        self.OpenGLControl1.Invalidate;
       end;

end;

// Zoom
procedure TForm1.OpenGLControl1MouseWheelDown(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
var diff_z:double;
begin
 diff_z:=abs(Position3d.z/5);
 if Position3d.z<0.3 then diff_z:=0.05;
 Position3d.z:=Position3d.z+diff_z;

 self.OpenGLControl1.Invalidate;
end;

// Zoom
procedure TForm1.OpenGLControl1MouseWheelUp(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
var diff_z:double;
begin
 diff_z:=abs(Position3d.z/5);
 if Position3d.z<0.3 then diff_z:=0.05;
 Position3d.z:=Position3d.z-diff_z;

 self.OpenGLControl1.Invalidate;
end;

// Szene zeichnen
procedure TForm1.OpenGLControl1Paint(Sender: TObject);
var kante,laenge:frfloat;
    zuletzt: dword; // zuletzt geklicktes Objektconst
    r,g,b:dWord;
    c:double=0.5;
begin
 // Hintergrund mit Farbe löschen
 glClearColor(0.9, 0.9, 0.9, 1.0);
 glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);

 glEnable(GL_DEPTH_TEST);

 // Projektionsmodus
 glMatrixMode(GL_PROJECTION);
 glLoadIdentity();
 gluPerspective(45, frfloat(OpenGLControl1.Parent.width) / OpenGLControl1.Parent.height, 0.01, 500.0);

 // Modellmodus
 glMatrixMode(GL_MODELVIEW);
 glLoadIdentity();

 // hier die Zeichnung
 // An die Position relativ zum Betrachter springen
 glTranslatef(position3d.x,position3d.y,position3d.z);
 // Die Szene drehen , es ist eine Kamarafahrt um das Objekt (Körper)
 glRotatef(winkel_um.x,1,0,0); // um X-Achse
 glRotatef(winkel_um.y,0,1,0); // um Y-Achse
 glRotatef(winkel_um.z,0,0,1); // um Z-Achse

 // Farbe schwarz für die Koordinatenachsen-Linien
 glcolor3f(0,0,0);
 // Ausgangslänge der Linie
 laenge:=0.1;
 // Die Achsen zeichnen
 glbegin(gl_lines);
  // X-Achse
  glvertex3f(0,0,0);
  glvertex3f(Laenge,0,0);
  glvertex3f(0,0,0);
  glvertex3f(-Laenge,0,0);
  // Y-Achse
  glvertex3f(0,0,0);
  glvertex3f(0,Laenge,0);
  glvertex3f(0,0,0);
  glvertex3f(0,-Laenge,0);
  // Z-Achse
  glvertex3f(0,0,0);
  glvertex3f(0,0,Laenge);
  glvertex3f(0,0,0);
  glvertex3f(0,0,-Laenge);
 glend;

 //Flächenmodus
 glPolygonMode(GL_FRONT_and_back, GL_fill);
 // Kantenlänge des Würfels
 kante:=laenge/2.5;

 // Hinweis:
 // Die Normalvektoren sind in diesem Beispiel eigentlich nicht nötig, weil es
 // ja kein Beleuchtungsmodell gibt,
 // Kann aber nicht schaden, wenn man sie drinn läßt.
 // Arbeitet man mit Beleuchtung sind die Normalvektoren unbedingt nötig, damit
 // OpenGL die Lichtreflektionen richtig berechnen kann.
 // Der Normalvektor ist die Linie, die senkrecht auf einer Fläche steht.

 // Würfel zeichnen
 // 1 Seite
 // Normalvektor der Würfel-Seite
 glNormal3f(0,0,1);
 // Farbe der Seite RGB mit Werten zwischen 0-1
 glcolor3f(c,0,0);
 // Poygon zeichnen , hier vier Punkte für die Kanten einer Würfelseite
 glBegin(GL_POLYGON);
  // Punkt1
  glvertex3f(-kante,kante,kante);
  // Punkt2
  glvertex3f(-kante,-kante,kante);
  // Punkt3
  glvertex3f(kante,-kante,kante);
  // Punkt4
  glvertex3f(kante,kante,kante);
 glend;
 // 2 Seite
 glNormal3f(-1,0,0);
 glcolor3f(0,c,0);
 glBegin(GL_POLYGON);
  glvertex3f(-kante,kante,-kante);
  glvertex3f(-kante,-kante,-kante);
  glvertex3f(-kante,-kante,kante);
  glvertex3f(-kante,kante,kante);
 glend;
 // 3 Seite
 glNormal3f(0,1,0);
 glcolor3f(0,0,c);
 glBegin(GL_POLYGON);
  glvertex3f(-kante,kante,-kante);
  glvertex3f(-kante,kante,kante);
  glvertex3f(kante,kante,kante);
  glvertex3f(kante,kante,-kante);
 glend;
 // 4 Seite
 glNormal3f(0,0,-1);
 glcolor3f(c,0,c);
 glBegin(GL_POLYGON);
  glvertex3f(kante,kante,-kante);
  glvertex3f(kante,-kante,-kante);
  glvertex3f(-kante,-kante,-kante);
  glvertex3f(-kante,kante,-kante);
 glend;
 // 5 Seite
 glNormal3f(1,0,0);
 glcolor3f(c,c,0);
 glBegin(GL_POLYGON);
  glvertex3f(kante,kante,kante);
  glvertex3f(kante,-kante,kante);
  glvertex3f(kante,-kante,-kante);
  glvertex3f(kante,kante,-kante);
 glend;
 // 6 Seite
 glNormal3f(0,-1,0);
 glcolor3f(0,c,c);
 glBegin(GL_POLYGON);
  glvertex3f(-kante,-kante,kante);
  glvertex3f(-kante,-kante,-kante);
  glvertex3f(kante,-kante,-kante);
  glvertex3f(kante,-kante,kante);
 glend;


 // Übertragen
 OpenGLControl1.SwapBuffers;

 // Farbe abfragen
 if picking
  then
   begin
    glReadPixels(Mausstart_3Dx,OpenGLControl1.Height-Mausstart_3Dy,1,1,gl_rgb,GL_UNSIGNED_byte,@zuletzt);

    r:=getrvalue(zuletzt);
    g:=getgvalue(zuletzt);
    b:=getbvalue(zuletzt);

    label1.caption:=inttostr(r)+' '+
                    inttostr(g)+' '+
                    inttostr(b);

    picking:=false;
   end;
end;

end.


